<?php
use Doctrine\DBAL\Types\IntegerType;
use Doctrine\DBAL\Schema\View;


class documents extends BaseCtrl{
	function __construct()
	{
		parent::__construct();
		$this->load->library('jsUtils');
	}
	
	
	public function index(){
		$this->load->view("v_header");
		//$this->loadalldocument();
		//$this->loaddocumentbytitle("test");
		echo "<hr>";
		$this->searchdocument();
	}
	
	
	
	public function refresh(){
		
	}
	
	
	//charge tout les documents
	public function loadalldocument(){
		$query = $this->doctrine->em->createQuery("SELECT d FROM Document d");
		$document = $query->getResult();
		$this->load->view('v_affichageDocument',array('documents'=>_loadDomaineByMonde(1)));
	}
	
	
	//charge le ou les document(s) par titre
	public function loaddocumentbytitle($titre){
		if($titre == "BtnRecherche"){
			$titre = $_POST['titre'];
			if ($titre == ""){
				$this->index();
			}
		}
		$query = $this->doctrine->em->createQuery("SELECT d FROM Document d WHERE d.titre LIKE :title ");
		$query->setParameter('title', '%'.$titre.'%');
		$document = $query->getResult();
		if(empty($document)){		
			$this->index();
			
		}
		else{
			$this->load->view('v_document',array('documents'=>$document));
		}
	}

					
	
	
	
	//recherche de(s) document(s)
	public function searchdocument(){
		
		$this->jsutils->postFormAndBindTo("#BtnRecherche","click", "loaddocumentbytitle","frmSearch","body");
		$this->jsutils->compile();
		$this->load->view('v_rechercheDocument');

	}
	
	////////////////////////////////////////////////////////////THEO/////////////////////////////////////////////////////////////////
	
	
	//charge les vues et le js
	public function mesDocs(){
		$this->jsutils->getAndBindTo('.classTheme','click', '/wikiPro/documents/lesDocs','#reponse');
		$this->jsutils->getAndBindTo('.modifTitre','click', '/wikiPro/documents/modifTitre','#modifier');
		$this->jsutils->getAndBindTo('.modifTheme','click', '/wikiPro/documents/modifTheme','#modifier');
		$this->jsutils->compile();
		$this->load->view('v_header');
		$this->load->view('v_arbo', array('domaines'=>$this->_loadDomaineByMonde($this->_getActiveUser()->getMonde()->getId()), 'themes'=>$this->_loadThemes()));
		$this->load->view('v_mesDocs',array('mesDocs'=>$this->_loadUserDocuments($this->_getActiveUser()->getId())));
		
	}
	
	//actualise la liste des documents
	public function lesDocs($param){
		$this->jsutils->getAndBindTo('.modifTitre','click', '/wikiPro/documents/modifTitre','#modifier');
		$this->jsutils->getAndBindTo('.modifTheme','click', '/wikiPro/documents/modifTheme','#modifier');
		$this->jsutils->compile();
		$idtheme=str_replace('theme', '', $param);
		$theme=DAO\getOne('theme', $idtheme);
		$this->load->view('v_mesDocs', array('mesDocs'=>$this->_loadDocumentsByTheme($idtheme),'theme'=>$theme));
	}
	
	
	//charge la vue pour modifier un thème de document
	public function modifTheme($param){
		$iddoc=str_replace('modifTheme', '', $param);
		$doc=DAO\getOne('document', $iddoc);
		
		$this->jsutils->click('#btFerme', $this->jsutils->hide('#bonjour'));
		$this->jsutils->postFormAndBindTo('.btTheme', 'click', '/wikiPro/documents/modifierTheme', 'frmTheme','#rep');
		$this->jsutils->compile();
		$this->load->view('v_modifTheme',array("doc"=>$doc,"themes"=>$this->_loadThemes()));
	}
	
	//modifie le theme d'un document
	public function modifierTheme($param){
		$iddoc=str_replace('btTheme', '', $param);
		$doc=DAO\getOne('document', $iddoc);
		//echo $doc->toString();
		$theme=$_POST['theme'];
		$themes=DAO\getAll('theme');
		foreach ($themes as $elt){
			if ($elt->getId()==$theme){
				$themefinal=$elt;
			}
		}
		$doc->setTheme($themefinal);
		DAO\update($doc);
		echo "Mise a jour du thème réussi.";				
	}
	
	//charge la vue pour modifier un titre de document
	public function modifTitre($param){
		$iddoc=str_replace('modifTitre', '', $param);
		$doc=DAO\getOne('document', $iddoc);
		$this->jsutils->click('#btFerme', $this->jsutils->hide('#bonjour'));
		$this->jsutils->postFormAndBindTo('.btTitre', 'click', '/wikiPro/documents/modifierTitre', 'frmTitre','#rep');
		$this->jsutils->compile();
		$this->load->view('v_modifTitre',array("doc"=>$doc,"themes"=>$this->_loadThemes()));
	}
	
	
	//fonction qui modifie la base de donnée et met a jour le titre
	public function modifierTitre($param){
		$iddoc=str_replace('btTitre', '', $param);
		$doc=DAO\getOne('document', $iddoc);
		$titre=$_POST['titre'];
		$doc->setTitre($titre);
		DAO\update($doc);
		echo "Mise a jour du titre réussi.";
	}
	
	//charge tous les documents de l'utilisateur
	public function _loadUserDocuments($idUser){
		$query = $this->doctrine->em->createQuery("SELECT d FROM Document d JOIN d.utilisateur u WHERE u.id='".$idUser."'");
		return $query->getResult();
	}
	
	//charge tous les documents du thème dont l'id est passer en parametre
	public function _loadDocumentsByTheme($idTheme){
		$query = $this->doctrine->em->createQuery("SELECT d FROM Document d JOIN d.theme t WHERE t.id='".$idTheme."'");
		return $query->getResult();
	}
	
	
	//charge tous les domaines du monde dont l'id est passer en parametre
	public function _loadDomaineByMonde($idmonde){
		$query = $this->doctrine->em->createQuery("SELECT d FROM domaine d JOIN d.monde m where m.id='".$idmonde."'");
		return $query->getResult();	
	}
	
	
	//Charge tous les thèmes existant
	public function _loadThemes(){
		return DAO\getAll('theme');
	}
	
	public function chargeEnfants($unDomaine){
		$themes=documents::_loadThemes();
		foreach ($themes as $elt){
			if ($elt->getDomaine()==$unDomaine){
				echo '<div class="margeTheme"><a class="classTheme" id="theme'.$elt->getId().'" href=#>'.$elt->_toString().'</a>';
				documents::chargeEnfants2($themes, $elt);
				echo '</div><br>';
			}
		}
		
	}
	
	public function chargeEnfants2($themes, $themeParent){
		foreach ($themes as $elt){
			if ($elt->getTheme()==$themeParent){
				echo '<div class="margeTheme"><a class="classTheme" id="theme'.$elt->getId().'" href=#>'.$elt->_toString().'</a>';
				documents::chargeEnfants2($themes, $elt);
				echo '</div>';
			}			
		}
	}
	
	
	
	public function _getActiveUser(){
		return DAO\getOne('utilisateur', '1');
	}
	
}
	
	
	
	